_TITLE "QB64 Sudoku App with recursive solver by bplus"
'created in QB64 version 1.1 20171106/82 (the day before vers 1.2 change)
'2018-01-24 fix number keypress, was not entered into grid as negative.

'2018-01-23 QB3 Sudoku App.bas
' + add recursive solver from JB forum, sub resolve() by cassiope01 on 18 Nov 2011
' - dump all other solver code, nothing compares as resolve will "solve" a blank board!
' + add all improvements made to Sudoku in SB version
' + navigate the keyboard with arrow keys and/or input numbers by keyboard
' + 6 functions menu > 7 with a Fill Menu item for Solving puzzle
'     and Help menu to toggle numbers available for spaces so that
'     all numbers legal for a space are displaced for you in small font!!!
'     all menu buttons have equivalent keypresses, just use first letter.

'from;  SB3 Sudoku Game and Solver.bas for SmallBASIC 0.12.11 (B+=MGA) 2018-01-17

'from: SB1 Sudoku Game.bas for SmallBASIC 0.12.11 (B+=MGA) 2018-01-17
' some edits of game posted 2018-01-17, better quit code with level
' more debug code removed

'from: sudoku mod bplus.bas SmallBASIC 0.12.11 (B+=MGA) 2018-01-06
' add whole new makeGrid (maybe faster) and hideCells code (not so random)

'Sudoku Game from SB.bas SmallBASIC 0.12.9 (B+=MGA) 2018-01-04
' fix color at start so can see the grid!
' add solved function!!! and loop around when solved
' removed cell notes, to store in corners option

CONST xmax = 440
CONST ymax = 570
SCREEN _NEWIMAGE(xmax, ymax, 32)
_SCREENMOVE 360, 20

DEFINT A-Z
RANDOMIZE TIMER

CONST TextSize = 8
CONST CellSize = TextSize * 5

CONST xMinBoard = CellSize
CONST yMinBoard = CellSize
CONST xMaxBoard = xMinBoard + 9 * CellSize
CONST yMaxBoard = yMinBoard + 9 * CellSize
CONST xMidBoard = xMinBoard + xMaxBoard / 2 - xMinBoard / 2
CONST yMidBoard = yMinBoard + yMaxBoard / 2 - yMinBoard / 2
CONST xMinKeyPad = xMinBoard - .5 * CellSize
CONST xMaxKeyPad = xMinKeyPad + CellSize * 10
CONST yMinKeyPad = yMaxBoard + 10
CONST yMaxKeyPad = yMinKeyPad + CellSize
CONST funcWide = xmax / 7
CONST yMinFunc = yMaxKeyPad + CellSize
CONST yMaxFunc = yMinFunc + CellSize

CONST blackl = &HFF000000
CONST redl = &HFF880000
CONST bluel = &HFF000088
CONST greyh = &HFFBABABA
CONST blueh = &HFF0000FF
CONST greenh = &HFF00FF00
CONST cyanh = &HFF00FFFF
CONST redh = &HFFFF0000
CONST purpleh = &HFFFF00FF
CONST yellowh = &HFFFFFF00
CONST whiteh = &HFFFFFFFF
CONST b = &HFF000040 'board background

COMMON SHARED bx, by, mkey, update, level, mode$, help, savedSolve
COMMON SHARED bArial&
DIM SHARED grid(8, 8), temp(8, 8)

'checkout fonts for large medium and small printing, decided to use QB64 default font for small and medium
ff$ = "arial" ' I have loaded and tested many fonts from Windows Folder and disappointed how few work with QB64
'load and check Big size font
bArial& = _LOADFONT("C:\windows\fonts\" + ff$ + ".ttf", 30, "BOLD")
IF bArial& <= 0 THEN PRINT "Trouble with " + ff$ + ".ttf size 30 file, goodbye.": SLEEP: END
'bFW = _FONTWIDTH(bArial&): bFH = _FONTHEIGHT(bArial&)
_FONT bArial&
LOCATE 1, 1: PRINT "This is BIG font."
_FONT 16
'SLEEP

'main loop sets up game puzzle,
'when solved it flashes that fact and then sets up another puzzle
WHILE 1
    getLevel
    'globals  SETUP for Game or Make Puzzle
    bx = 0: by = 0 '      current highlighted location on board
    mkey = 1 '            current key highlighted on keyPad, key = 0 clears cell
    update = 1 '          when to show game board
    mode$ = "p" '         2 modes: p for puzzle and m for make puzzle
    help = 0 '            help mode will display numbers legal and available in spaces
    '                     the h key or the Help Menu function will Toggle this feature on/off
    ERASE grid '          9x9 board positive values are puzzle clues
    '                     0 value in grid is blank cell to fill out
    '                     neg values in grid are players guesses to solve puzzle
    makeGrid
    hideCells
    savedSolve = 0
    WHILE 1
        IF update THEN showGrid
        k$ = INKEY$
        IF LEN(k$) THEN
            update = 1
            IF LEN(k$) = 1 THEN
                IF k$ = "f" THEN
                    resolve
                ELSEIF k$ = "h" THEN
                    IF help THEN help = 0 ELSE help = 1
                ELSEIF k$ = "m" OR k$ = "p" THEN
                    mode$ = k$: update = 1
                    IF k$ = "m" THEN 'convert grid to all positive values
                        FOR row = 0 TO 8
                            FOR col = 0 TO 8
                                grid(col, row) = ABS(grid(col, row))
                            NEXT
                        NEXT
                    END IF
                ELSEIF k$ = "s" THEN
                    savePZ 0
                ELSEIF k$ = "l" THEN
                    loadPZ
                ELSEIF k$ = "e" THEN
                    EXIT WHILE
                ELSEIF INSTR("0123456789", k$) THEN
                    handleNumber VAL(k$)
                ELSEIF ASC(k$) = 27 THEN
                    CLS: END
                ELSE
                    update = 0
                END IF
            ELSEIF LEN(k$) = 2 THEN
                SELECT CASE ASC(RIGHT$(k$, 1))
                    CASE 72: IF by > 0 THEN by = by - 1 'up arrow
                    CASE 80: IF by < 8 THEN by = by + 1 'down arrow
                    CASE 75: IF bx > 0 THEN bx = bx - 1 'left arrow
                    CASE 77: IF bx < 8 THEN bx = bx + 1 'right arrow
                    CASE ELSE: update = 0
                END SELECT
            END IF
        END IF

        'get next mouse click, check if in board and if so update x, y
        m = _MOUSEINPUT: mb = _MOUSEBUTTON(1): mx = _MOUSEX: my = _MOUSEY
        IF mb THEN 'get last place mouse button was down
            mb = _MOUSEBUTTON(1): mx = _MOUSEX: my = _MOUSEY
            WHILE mb 'left button down, wait for mouse button release
                m = _MOUSEINPUT: mb = _MOUSEBUTTON(1): mx = _MOUSEX: my = _MOUSEY
            WEND
            'clicked inside Board?
            IF xMinBoard <= mx AND mx <= xMaxBoard AND yMinBoard <= my AND my <= yMaxBoard THEN
                bx = INT((mx - xMinBoard) / CellSize): by = INT((my - yMinBoard) / CellSize)
                IF grid(bx, by) < 1 OR mode$ = "m" THEN
                    IF mkey = 0 THEN
                        grid(bx, by) = 0
                    ELSE
                        IF aok(mkey, bx, by) THEN
                            IF mode$ = "p" THEN grid(bx, by) = -mkey ELSE grid(bx, by) = mkey
                        ELSE
                            BEEP
                        END IF
                    END IF
                ELSE
                    BEEP
                END IF
                update = 1
            END IF
            'clicked inside keyPad?
            IF xMinKeyPad <= mx AND mx <= xMaxKeyPad AND yMinKeyPad <= my AND my <= yMaxKeyPad THEN
                mkey = INT((mx - xMinKeyPad) / CellSize)
                update = 1
            END IF
            'clicked inside Func menu: fill (solve), help (toggle clues), play mode, make mode, save file, load file, quit screen
            IF 0 <= mx AND mx <= xmax THEN
                IF yMinFunc < my AND my < yMaxFunc THEN
                    update = 1
                    xf# = mx / funcWide
                    IF xf# <= 1 THEN ' solve
                        resolve
                    ELSEIF xf# <= 2 THEN 'toggle help on/off
                        IF help THEN help = 0 ELSE help = 1
                    ELSEIF xf# <= 3 THEN 'play mode
                        mode$ = "p"
                    ELSEIF xf# <= 4 THEN 'make mode
                        mode$ = "m"
                        FOR rrow = 0 TO 8
                            FOR ccol = 0 TO 8
                                grid(ccol, rrow) = ABS(grid(ccol, rrow))
                            NEXT
                        NEXT
                    ELSEIF xf# <= 5 THEN 'save file
                        savePZ (0)
                    ELSEIF xf# <= 6 THEN 'load file
                        loadPZ
                    ELSEIF xf# <= 7 THEN 'exit
                        EXIT WHILE
                    END IF
                END IF
            END IF
        END IF
        IF solved AND savedSolve = 0 THEN savedSolve = 1: BEEP: savePZ (1)
        _DISPLAY
        _LIMIT 1000 '? save fan?
    WEND
WEND

SUB handleNumber (ky)
    IF grid(bx, by) < 1 OR mode$ = "m" THEN 'don't change clues in puzzle mode
        IF ky = 0 THEN
            grid(bx, by) = 0
        ELSE
            IF aok(ky, bx, by) THEN 'is this a bad idea = bad key?
                IF mode$ = "p" THEN grid(bx, by) = -ky ELSE grid(bx, by) = ky
            ELSE
                BEEP ' bad idea for puzzle mode and make mode
            END IF
        END IF
    ELSE
        BEEP ' don't change clues!
    END IF
END SUB

FUNCTION solved ()
    solved = 0 'n must be found in every column, row and 3x3 cell
    FOR n = 1 TO 9
        'check columns for n
        FOR col = 0 TO 8
            found = 0
            FOR row = 0 TO 8
                IF ABS(grid(col, row)) = n THEN found = 1: EXIT FOR
            NEXT
            IF found = 0 THEN EXIT FUNCTION
        NEXT
        'check rows for n
        FOR row = 0 TO 8
            found = 0
            FOR col = 0 TO 8
                IF ABS(grid(col, row)) = n THEN found = 1: EXIT FOR
            NEXT
            IF found = 0 THEN EXIT FUNCTION
        NEXT
        'check 3x3 cells for n
        FOR cell = 0 TO 8
            cellcol = cell MOD 3
            cellrow = INT(cell / 3)
            found = 0
            FOR col = 0 TO 2
                FOR row = 0 TO 2
                    IF ABS(grid(cellcol * 3 + col, cellrow * 3 + row)) = n THEN found = 1: EXIT FOR
                NEXT
                IF found = 1 THEN EXIT FOR
            NEXT
            IF found = 0 THEN EXIT FUNCTION
        NEXT
    NEXT
    solved = 1
END FUNCTION

SUB showGrid ()
    update = 0 'global calls for this display
    COLOR whiteh, b: CLS
    IF mode$ = "p" THEN s$ = " Puzzle:    Puzzle Mode" ELSE s$ = " Puzzle:      Make Mode"
    IF level = -1 THEN
        LOCATE 2, 8: PRINT "Sudoku Loaded File"; s$
    ELSE
        LOCATE 2, 10: PRINT "Sudoku Level "; RIGHT$(STR$(level), 1); s$
    END IF
    'draw line segments
    i = xMinBoard
    FOR x = 0 TO 9
        LINE (i, yMinBoard)-(i, yMaxBoard), purpleh
        i = i + CellSize
    NEXT x
    j = yMinBoard
    FOR y = 0 TO 9
        LINE (xMinBoard, j)-(xMaxBoard, j), purpleh
        j = j + CellSize
    NEXT y
    'draw heavy 3x3 cell borders
    LINE (xMinBoard + 1, yMinBoard + 1)-(xMaxBoard + 1, yMaxBoard + 1), whiteh, B
    i = xMinBoard + (CellSize * 3) + 1
    LINE (i, yMinBoard)-(i, yMaxBoard), whiteh
    i = xMinBoard + (CellSize * 6) + 1
    LINE (i, yMinBoard)-(i, yMaxBoard), whiteh
    j = yMinBoard + (CellSize * 3) + 1
    LINE (xMinBoard, j)-(xMaxBoard, j), whiteh
    j = yMinBoard + (CellSize * 6) + 1
    LINE (xMinBoard, j)-(xMaxBoard, j), whiteh
    FOR y = 0 TO 8
        FOR x = 0 TO 8
            IF help THEN
                'make a string of available candidates for cell
                cs$ = ""
                FOR n = 1 TO 9
                    IF aok(n, x, y) THEN cs$ = cs$ + RIGHT$(STR$(n), 1)
                NEXT
            END IF
            'highlite?
            IF x = bx AND y = by THEN
                COLOR b, 10
                LINE (xMinBoard + x * CellSize + 3, yMinBoard + y * CellSize + 3)-STEP(CellSize - 5, CellSize - 5), greenh, BF
            ELSE
                IF grid(x, y) > 0 THEN COLOR blueh, b ELSE COLOR greyh, b
            END IF
            IF grid(x, y) <> 0 THEN
                _FONT bArial&
                _PRINTSTRING (xMinBoard + (x * CellSize) + TextSize + 5, yMinBoard + (y * CellSize) + 9), RIGHT$(STR$(ABS(grid(x, y))), 1)
                _FONT 16
            ELSE
                IF help THEN
                    _FONT 8
                    IF LEN(cs$) > 4 THEN
                        _PRINTSTRING (xMinBoard + x * CellSize + 3, yMinBoard + y * CellSize + 3), MID$(cs$, 1, 4)
                        _PRINTSTRING (xMinBoard + x * CellSize + 3, yMinBoard + y * CellSize + 12), MID$(cs$, 5)
                    ELSE
                        _PRINTSTRING (xMinBoard + x * CellSize + 3, yMinBoard + y * CellSize + 3), cs$
                    END IF
                    _FONT 16
                END IF
            END IF
        NEXT
    NEXT
    'show a keypad key with highlite
    i = xMinKeyPad
    FOR x = 0 TO 9
        IF x = mkey THEN
            LINE (i + 3, yMinKeyPad + 3)-STEP(CellSize - 5, CellSize - 5), greenh, BF
            COLOR b, greenh
        ELSE
            COLOR cyanh, b
        END IF
        LINE (i, yMinKeyPad)-(i, yMaxKeyPad), greyh
        _PRINTSTRING (i + (TextSize * 2), yMinKeyPad + TextSize + 4), RIGHT$(STR$(x), 1)
        i = i + CellSize
    NEXT
    LINE (xMinKeyPad, yMinKeyPad)-(xMaxKeyPad, yMaxKeyPad), greyh, B
    'function menu
    COLOR cyanh, redh
    FOR i = 0 TO 6
        LINE (i * funcWide + 5, yMinFunc + 5)-((i + 1) * funcWide - 5, yMaxFunc - 5), redh, BF
        SELECT CASE i
            CASE 0: _PRINTSTRING (i * funcWide + 17, yMinFunc + 13), "Fill"
            CASE 1: _PRINTSTRING (i * funcWide + 17, yMinFunc + 13), "Help"
            CASE 2: _PRINTSTRING (i * funcWide + 17, yMinFunc + 13), "Play"
            CASE 3: _PRINTSTRING (i * funcWide + 17, yMinFunc + 13), "Make"
            CASE 4: _PRINTSTRING (i * funcWide + 17, yMinFunc + 13), "Save"
            CASE 5: _PRINTSTRING (i * funcWide + 17, yMinFunc + 13), "Load"
            CASE 6: _PRINTSTRING (i * funcWide + 17, yMinFunc + 13), "Exit"
        END SELECT
    NEXT
    _DISPLAY
END SUB

SUB makeGrid 'this version requires the assistance of loadBox sub routine
    DO
        ERASE grid, temp
        startOver = 0
        FOR n = 1 TO 9
            FOR r = 0 TO 8
                FOR c = 0 TO 8
                    temp(c, r) = grid(c, r)
                NEXT
            NEXT
            cnt = 0
            DO
                FOR cellBlock = 0 TO 8
                    success = loadBox(n, cellBlock)
                    IF success = 0 THEN
                        cnt = cnt + 1 'EDIT remove the counters used to test code tCnt and tStartOver
                        IF cnt >= 20 THEN startOver = 1: EXIT FOR
                        FOR r = 0 TO 8
                            FOR c = 0 TO 8
                                grid(c, r) = temp(c, r)
                            NEXT
                        NEXT

                        EXIT FOR
                    END IF
                NEXT
                IF startOver THEN EXIT DO
            LOOP UNTIL success
            IF startOver THEN EXIT FOR
        NEXT
    LOOP UNTIL startOver = 0
END SUB

SUB hideCells
    FOR box = 0 TO 8
        cBase = (box MOD 3) * 3
        rBase = INT(box / 3) * 3
        dx = INT(RND * 2) + 1: dy = INT(RND * 2) + 1
        IF RND < .5 THEN dm = -1 ELSE dm = 1
        bx = INT(RND * 3): by = INT(RND * 3)
        FOR m = 0 TO level - 1
            grid(cBase + ((bx + m * dx) MOD 3), rBase + (by + m * dy + INT(m / 3) * dm) MOD 3) = 0
        NEXT
    NEXT
END SUB

FUNCTION aok (a, c, r) 'check to see if a is OK to place at (c, r)
    aok = 0
    IF grid(c, r) = 0 THEN 'check cell empty
        FOR i = 0 TO 8 'check row and column
            IF ABS(grid(i, r)) = a OR ABS(grid(c, i)) = a THEN EXIT FUNCTION
        NEXT
        cbase = INT(c / 3) * 3: rbase = INT(r / 3) * 3
        FOR rr = 0 TO 2
            FOR cc = 0 TO 2
                IF ABS(grid(cbase + cc, rbase + rr)) = a THEN EXIT FUNCTION
            NEXT
        NEXT
        aok = 1
    END IF
END SUB

FUNCTION loadBox (n, box) 'this one uses aok function to help load boxes
    xoff = 3 * (box MOD 3): yoff = 3 * INT(box / 3)
    'make a list of free cells in cellblock
    DIM clist(8)
    FOR y = 0 TO 2 'make list of cells available
        FOR x = 0 TO 2 'find open cell in cellBlock first
            IF aok(n, xoff + x, yoff + y) THEN available = available + 1: clist(3 * y + x) = 1
        NEXT
    NEXT
    IF available = 0 THEN
        EXIT FUNCTION
    END IF
    DIM cell(1 TO available): pointer = 1
    FOR i = 0 TO 8
        IF clist(i) THEN cell(pointer) = i: pointer = pointer + 1
    NEXT
    'OK our list has cells available to load, pick one randomly
    IF available > 1 THEN 'shuffle cells
        FOR i = available TO 2 STEP -1
            r = INT(RND * i) + 1
            SWAP cell(i), cell(r)
        NEXT
    END IF
    'load the first one listed
    grid(xoff + (cell(1) MOD 3), yoff + INT(cell(1) / 3)) = n
    loadBox = 1
END SUB

SUB savePZ (saveSolved)
    IF saveSolved THEN
        fName$ = "Temp Solved Puzzle.txt": savedSolve = 1
    ELSE
        fName$ = "Temp Saved Puzzle.txt"
    END IF
    OPEN fName$ FOR OUTPUT AS #1
    FOR r = 0 TO 8
        s$ = ""
        FOR c = 0 TO 8
            s$ = s$ + RIGHT$("   " + STR$(grid(c, r)), 3)
        NEXT
        PRINT #1, s$
    NEXT
    CLOSE #1
    showGrid
    COLOR blueh, cyanh
    IF saveSolved THEN s$ = "  Solved! Saved to: " ELSE s$ = "  Puzzle Saved to: "
    s$ = s$ + fName$ + "  "
    cp 29, s$
END SUB

SUB loadPZ ()
    OPEN "Temp Saved Puzzle.txt" FOR INPUT AS #1
    FOR row = 0 TO 8
        INPUT #1, fl$
        FOR i = 0 TO 8
            n = VAL(MID$(fl$, 3 * i + 1, 2))
            grid(i, row) = n
        NEXT
    NEXT
    CLOSE #1
    savedSolve = 0
    level = -1 'signal no longer using the puzzle setup from getLevel intro
END SUB

' resolve sub written by cassiope01 on 18 Nov 2011,
' modified very slightly by TyCamden on 19 Nov 2011,
' modified more by me for testing code at JB in mainwin code:
' use aok() function in place of ok() as it does
' the same thing without string processing.

' Now modified by me more, to use in SB but too many stack
' overflow errors in SB, try QB64, Oh yeah!!! Nice...
SUB resolve ()
    FOR r = 0 TO 8
        FOR c = 0 TO 8
            IF grid(c, r) = 0 THEN
                FOR n = 1 TO 9
                    IF aok(n, c, r) THEN
                        temp = grid(c, r)
                        grid(c, r) = -n
                        resolve
                        IF complete THEN EXIT SUB
                        grid(c, r) = temp
                    END IF
                NEXT
                EXIT SUB
            END IF
        NEXT
    NEXT
END SUB

'for resolve
FUNCTION complete () 'grid finished ?
    FOR r = 0 TO 8
        FOR c = 0 TO 8
            IF grid(c, r) = 0 THEN EXIT FUNCTION
        NEXT
    NEXT
    complete = 1
END FUNCTION

SUB getLevel () 'isolated to work on independently
    'get desired level of difficulty set
    COLOR greyh, redl: CLS

    cp 2, "*** Sudoku Application for QB64 by bplus ***"

    cp 4, "Features 7 Function Menu:"
    lp 1, 6, "1 Fill - solves any solvable puzzle even a blank!"
    lp 1, 7, "2 Help - toggles between showing legal numbers or not."
    lp 1, 8, "3 Play - normal Puzzle mode (guesses are neg)."
    lp 1, 9, "4 Make - for puzzle creation (clues are pos)."
    lp 1, 10, "5 Save - file a puzzle at any stage (pos and neg)."
    lp 1, 11, "6 Load - load the filed puzzle back."
    lp 1, 12, "7 Exit - comes back here for new level or quit."

    cp 14, "Levels 1 to 3 are good for developing"
    cp 15, "'flash card' automatic skills."
    cp 17, "Levels 4, 5 and 6 are easy standard for:"
    cp 18, "beginner, intermediate, and difficult puzzles."

    cp 20, "Use level 9 to blank a puzzle and input your own."
    lp 2, 21, "press m for Make mode (enters pos values in grid)."
    lp 2, 22, "Press s to Save, files to Temp Saved Puzzle.txt"
    lp 2, 23, "press l to Load that puzzle up again."

    cp 25, "When a puzzle is Solved it is automatically saved"
    cp 26, "to Temp Solved Puzzle.txt use your OS to manage these"
    cp 27, "files to rename or file in other folders for storage."
    COLOR yellowh, redl
    cp 30, "Now about that level? Enter 0 to 9 any else quits "
    lvl$ = ""
    LOCATE 33, 25: INPUT ; lvl$
    IF lvl$ = "" THEN
        CLS: END
    ELSE
        IF INSTR("0123456789", lvl$) THEN level = VAL(lvl$) ELSE CLS: END
    END IF
END SUB

SUB cp (cpRow, text$)
    _PRINTSTRING ((xmax - 8 * LEN(text$)) / 2, cpRow * 16), text$
END SUB

SUB lp (spacer, lpRow, text$)
    _PRINTSTRING (spacer * 8, lpRow * 16), text$
END SUB
